#ifndef pctfunctions_H
#define pctfinctions_H


// References:
// [1] http://graphcomp.com/info/specs/ms/pct.htm


#define PCT1_HANDSHAKE_TYPE_SERVER_HELLO	0x02

typedef struct tagPCT_CIPHER
{

	WORD cipher;
	BYTE encryptionLength;
	BYTE macLength;

}PCT_CIPHER;


typedef struct tagPCT_HELLO
{
	WORD length;
	unsigned char CH_MSG_CLIENT_HELLO;
	WORD CH_CLIENT_VERSION;
	unsigned char CH_PAD;
	unsigned char CH_SESSION_ID_DATA[32];
	unsigned char CH_CHALLENGE_DATA[32];
	WORD CH_OFFSET;
	WORD CH_CIPHER_SPECS_LENGTH;
	WORD CH_HASH_SPECS_LENGTH;
	WORD CH_CERT_SPECS_LENGTH;
	WORD CH_EXCH_SPECS_LENGTH;
	WORD CH_KEY_ARG_LENGTH;

	PCT_CIPHER *specs;	

	WORD *CH_HASH_SPECS_DATA; //[(MSB << 8)|LSB]
	WORD *CH_CERT_SPECS_DATA; //[(MSB << 8)|LSB]
	WORD *CH_EXCH_SPECS_DATA; //[(MSB << 8)|LSB]

} PCT_HELLO;


BOOL pctTestConnection(PCT_CIPHER *ciphers, WORD cipherLen, SOCKADDR_IN lSockAddr, int secondTimeout);

#endif
