/**
 * SSLPressure 
 * Author: James Dickson.
 * License: GPL v3
 */
#ifndef ssl2functions_h
#define ssl2functions_h

#include <stdio.h>
#include <winsock2.h>
#include <time.h>
#include "tlsfunctions.h"

#define SSL2_HANDSHAKE_TYPE_SERVER_HELLO	0x04
#define SSL_CONTENT_TYPE_HANDSHAKE			0x01

// 11 bytes
typedef struct tagSSL_RECORD
{
	WORD length;
	BYTE handshakeMessageType;
	WORD version;
	WORD cipherSpecLength;
	WORD sessionIDLength;
	WORD challengeLength;
}SSL_RECORD;

// 
typedef struct tagSSL_CLIENT_HELLO_START
{
	SSL_RECORD sslRecord;
	BYTE *cipherSpecs;
	BYTE challenge[16];

}SSL_CLIENT_HELLO_START;

void ssl2CreateHelloMessage(SSL_CLIENT_HELLO_START *msg, WORD ssl_version, DWORD cipher);
//int ssl2SendClientHelloMessage(SSL_CLIENT_HELLO_START *msg, SOCKET lhSocket);
int ssl2SendClientHelloMessage(SSL_CLIENT_HELLO_START *msg, SOCKET lhSocket, int rawLength);

BOOL ssl2TestConnection(
						   //WORD tls_version, 
						   WORD *cipher, 
						   TLS_EXTENSION *extensions, 
						   WORD extensionLength, 
						   DWORD cipherCount,
						   SOCKADDR_IN lSockAddr,
						   int secondTimeout,
						   WORD currentSSLVersion, 
						   WORD *foundCipher, 
						   DWORD dwCipher,
						   DWORD *dwFoundCipher);

#endif
