/**
 * SSLPressure 
 * Author: James Dickson.
 * License: GPL v3
 */
#include <stdio.h>
#include <winsock2.h>

/**
 * Create a TCP-connection
 */
int getConnection(SOCKET *lhSocket, SOCKADDR_IN *lSockAddr, int secondTimeout)
{
	// Create socket
	*lhSocket = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);

	// Set the timeout for Read-operation.
	struct timeval tv;
	tv.tv_sec = secondTimeout;
	tv.tv_usec = 0;

	// This timeout is important for our 3Com wlan gadget.
	if (setsockopt(*lhSocket, SOL_SOCKET, SO_RCVTIMEO, (char *)&tv,  sizeof tv))
	{	
		printf("[-] ERROR: Could not setsockopt...\n");
		return 0;
	}

    // Connect the TCP socket
	int lConnect = connect(*lhSocket,(SOCKADDR *)lSockAddr, sizeof(SOCKADDR_IN));
	if(lConnect != 0)
	{
		printf("[-] ERROR: Could not perform TCP-handshake. Return code: %d\n", lConnect);
		return 0;
	}

	return 1;
}

/**
 * Init the Win32 socket
 */
int initWSA()
{
#ifdef WIN32
	WSADATA wsaData;

	if(WSAStartup(MAKEWORD(2,0),&wsaData) != 0)
	{
		return 0;
	}

#endif
	
	return 1;
}

int initLibraries()
{
	int initSocket = initWSA();	// Initialize winsock

	// Check the WSA-init result.
	if(initSocket != 1)
	{
		printf("[-] ERROR: Could not initialize Win32 socket!\n");
		exit(-1);
	}
	
	return 0;
}
